#include <iostream>
#include "GumballMachine.h"

using namespace std;

void GumballMachine::release_ball()
{
    cout << "A gumball comes rolling out the slot..." << endl;
    if (count != 0) --count;
}

ostream& operator <<(ostream& os, const GumballMachine& gumball_machine)
{
    os << endl;
    os << "Mighty Gumball, Inc." << endl;
    os << "C++-enabled Standing Gumball Model #2004" << endl;

    os << "Inventory: " << gumball_machine.count << " gumball";
    if (gumball_machine.count != -1) cout << "s";
    os << endl << endl;

    os << "Machine is " << *(gumball_machine.state) << endl;

    return os;
}
