/**
 * Ported from the Java example program in
 * Head First Design Patterns, 1st edition
 * by Eric Freeman, Bert Bates, and Elizabeth Robson
 * O'Reilly, 2004
 * ISBN 978-0596007126
 *
 * Ported to C++ by:
 * Ronald Mak, Nov. 2019
 * Department of Computer Engineering
 * San Jose State University
 */
#include "GumballMachine.h"

int main()
{
    GumballMachine *gumball_machine = new GumballMachine(10);

    cout << *gumball_machine << endl;

    gumball_machine->insert_quarter();
    gumball_machine->turn_crank();
    gumball_machine->insert_quarter();
    gumball_machine->turn_crank();

    cout << *gumball_machine << endl;

    gumball_machine->insert_quarter();
    gumball_machine->turn_crank();
    gumball_machine->insert_quarter();
    gumball_machine->turn_crank();

    cout << *gumball_machine << endl;

    gumball_machine->insert_quarter();
    gumball_machine->turn_crank();
    gumball_machine->insert_quarter();
    gumball_machine->turn_crank();

    cout << *gumball_machine << endl;

    gumball_machine->insert_quarter();
    gumball_machine->turn_crank();
    gumball_machine->insert_quarter();
    gumball_machine->turn_crank();

    cout << *gumball_machine << endl;

    gumball_machine->insert_quarter();
    gumball_machine->turn_crank();
    gumball_machine->insert_quarter();
    gumball_machine->turn_crank();

    cout << *gumball_machine << endl;

    return 0;
}
