#include "GumballMachine.h"
#include "WinnerState.h"

void WinnerState::insert_quarter()
{
    cout << "Please wait, we're already giving you a Gumball" << endl;
}

void WinnerState::eject_quarter()
{
    cout << "Please wait, we're already giving you a Gumball" << endl;
}

void WinnerState::turn_crank()
{
    cout << "Turning again doesn't get you another gumball!" << endl;
}

void WinnerState::dispense()
{
    gumball_machine->release_ball();

    if (gumball_machine->get_count() == 0)
    {
        gumball_machine->set_state(gumball_machine->get_sold_out_state());
    }
    else
    {
        gumball_machine->release_ball();
        cout << "YOU'RE A WINNER! You got two gumballs for your quarter" << endl;

        if (gumball_machine->get_count() > 0)
        {
            gumball_machine->set_state(gumball_machine->get_no_quarter_state());
        }
        else
        {
            cout << "Oops, out of gumballs!" << endl;
            gumball_machine->set_state(gumball_machine->get_sold_out_state());
        }
    }
}
