#include "GumballMachine.h"
#include "HasQuarterState.h"

void HasQuarterState::insert_quarter()
{
    cout << "You can't insert another quarter" << endl;
}

void HasQuarterState::eject_quarter()
{
    cout << "Quarter returned" << endl;
    gumball_machine->set_state(gumball_machine->get_no_quarter_state());
}

void HasQuarterState::turn_crank()
{
    cout << "You turned..." << endl;

    int winner = rand()%10;
    if ((winner == 0) && (gumball_machine->get_count() > 1))
    {
        gumball_machine->set_state(gumball_machine->get_winner_state());
    }
    else
    {
        gumball_machine->set_state(gumball_machine->get_sold_state());
    }
}

void HasQuarterState::dispense()
{
}
