#include "GumballMachine.h"
#include "SoldState.h"

void SoldState::insert_quarter()
{
    cout << "Please wait, we're already giving you a gumball" << endl;
}

void SoldState::eject_quarter()
{
    cout << "Sorry, you already turned the crank" << endl;
}

void SoldState::turn_crank()
{
    cout << "Turning twice doesn't get you another gumball!" << endl;
}

void SoldState::dispense()
{
    gumball_machine->release_ball();

    if (gumball_machine->get_count() > 0)
    {
        gumball_machine->set_state(gumball_machine->get_no_quarter_state());
    }
    else
    {
        cout << "Oops, out of gumballs!" << endl;
        gumball_machine->set_state(gumball_machine->get_sold_out_state());
    }
}
